routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('frontend.home.index');
});
Route::get('/shop', function () {
    return view('frontend.shop.index');
});
Route::get('/product', function () {
    return view('frontend.product.index');
});
Route::get('/cart', function(){
    return view('frontend.cart.index');
});

Route::group([
    'prefix' => 'admin',
    'as' => 'be.',
    'namespace' => 'backend',
    'middleware' => ['web'],
], function(){
    Route::resource('category','CategoryController');
    Route::resource('manufacture','ManufactureController');
    Route::resource('product','ProductController');
    Route::resource('attribute','AttributeController');
    Route::resource('customer','CustomerController');
    Route::resource('order','CustomerController');
    //route for ajax to manage product attribute
    Route::post('product/attribute',['as' => 'product.attribute.get','uses' => 'ProductController@getAttributes']);
    Route::post('product/attribute/add',['as' => 'product.attribute.add','uses' => 'ProductController@addAttribute']);
    Route::post('product/attribute/update',['as' => 'product.attribute.update','uses' => 'ProductController@updateAttribute']);
    Route::post('product/attribute/destroy',['as' => 'product.attribute.destroy','uses' => 'ProductController@destroyAttribute']);
    Route::post('product/attribute/get',['as' => 'product.attribute.getsingle','uses' => 'ProductController@getSingleAttribute']);
});

app/Http/Controllers/Backend/AttributeController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Eloquent\Attribute;
use Session;
use DB;
class AttributeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $attributes = Attribute::all();
        return view('backend.attribute.index', compact('attributes'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backend.attribute.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $attribute = new Attribute();
        $attribute->name = $request->name;
        if($attribute->save()){
            Session::flash('message','Thêm thuộc tính sản phẩm thành công!');
            Session::flash('alert-class','alert-success');
        }else{
            Session::flash('message','Lỗi! Không thêm được thuộc tính');
            Session::flash('alert-class','alert-danger');
        }
        if($request->has('save-continue')){
            return redirect()->route('be.attribute.edit',$attribute->id);
        }
        return redirect()->route('be.attribute.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $attribute = Attribute::findOrFail($id);

        return view('backend.attribute.edit',compact('attribute'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $attribute = Attribute::where('id',$id)->with('attribute_values.product.category')->first();

        return view('backend.attribute.edit',compact('attribute'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $attribute = Attribute::findOrFail($id);
        $attribute->name = $request->name;
        if($attribute->update()){
            Session::flash('message','Chỉnh sửa thuộc tính sản phẩm thành công');
            Session::flash('alert-class','alert-success');
        }else{
            Session::flash('message','Lỗi! Không thể chỉnh sửa thuộc tính');
            Session::flash('alert-class','alert-success');
        }
        if($request->has('save-continue')){
            return redirect()->route('be.attribute.edit',$id);
        }
        return redirect()->route('be.attribute.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $attribute = Attribute::findOrFail($id);
        DB::table('attribute_value')->where('attribute_id',$id)->delete();
        if($attribute->delete()){
            Session::flash('message','Chỉnh sửa thuộc tính sản phẩm thành công');
            Session::flash('alert-class','alert-success');
        }else{
            Session::flash('message','Lỗi! Không thể xóa thuộc tính');
            Session::flash('alert-class','alert-danger');
        }
       return redirect()->route('be.attribute.index');
    }
}

app/Http/Controllers/Backend/CategoryController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Eloquent\Category;
use App\Eloquent\Product;
use Session;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::all();
        return view('backend.category.index', compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Category::all();
        return view('backend.category.create', compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $category = new Category();
        $category->name = trim($request->categoryname);
        $category->description = trim($request->description);
        $category->parent_id = $request->parent_id;
        if(!empty($request->image)){
            $category->image = $request->image->storeAs('app/public/category_images', ($category->name).date('mdYhis'));
        } 
        $category->display_order = $request->display_order;
        if(!empty($request->display_on_sidebar)){
            $category->display_in_sidebar = $request->display_on_sidebar;
        }
        if(!empty($request->display_on_homepage)){
            $category->display_in_homepage = $request->display_on_homepage;
        }
        if(!empty($request->display_on_topbar)){
            $category->display_in_topbar = $request->display_on_topbar;
        }
        $category->meta_keywords = trim($request->meta_keywords);
        $category->meta_description = trim($request->meta_description);
        if(empty($request->meta_title)){
            $category->meta_title = $category->name;
        }else{
            $category->meta_title = trim($request->meta_title);
        }
        if(empty($request->meta_anchor)){
            $meta_anchor = trim($category->name);
        }else{
            $meta_anchor = trim($request->meta_anchor);
        }
        $meta_anchor = str_replace('html','',$meta_anchor);
        $meta_anchor = str_slug($meta_anchor,'-','en');
        
        if(count(Category::where('meta_anchor',$meta_anchor.'html')->get())>0){
            $meta_anchor = $meta_anchor.'-'.str_random(5);          
        }
        $meta_anchor = $meta_anchor.'.html';
        $category->meta_anchor = $meta_anchor;
        $category->save();
        Session::flash('message','Tạo mới danh mục thành công!');
        Session::flash('alert-class','alert-success');
        if($request->has('save-continue')){
            return redirect()->route('be.category.edit',$category->id);
        }
       return redirect()->route('be.category.index');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $category = Category::findOrFail($id);
        $categories = Category::all();
        return view('backend.category.edit',compact('category','categories'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $category = Category::findOrFail($id);
        $category->name =trim($request->categoryname);
        $category->description = trim($request->description);
        $category->parent_id = $request->parent_id;
        if(!empty($request->image)){
            Storage::delete($category->image);
           $category->image = $request->image->storeAs('app/public/images/category', ($category->name).date('mdYhis'));
        } 
        $category->display_order = $request->display_order;
        if(!empty($request->display_on_sidebar)){
            $category->display_in_sidebar = $request->display_on_sidebar;
        }
        if(!empty($request->display_on_homepage)){
            $category->display_in_homepage = $request->display_on_homepage;
        }
        if(!empty($request->display_on_topbar)){
            $category->display_in_topbar = $request->display_on_topbar;
        }
        $category->meta_keywords = trim($request->meta_keywords);
        $category->meta_description = trim($request->meta_description);
        if(empty($request->meta_title)){
            $category->meta_title = $category->name;
        }else{
            $category->meta_title = trim($request->meta_title);
        }
        if(empty($request->meta_anchor)){
            $meta_anchor = trim($category->name);
        }else{
            $meta_anchor = trim($request->meta_anchor);
        }
        $meta_anchor = str_replace('html','',$meta_anchor);
        $meta_anchor = str_slug($meta_anchor,'-','en');
        
        if(count(Category::where('meta_anchor',$meta_anchor.'html')->get())>0){
            $meta_anchor = $meta_anchor.'-'.str_random(5);          
        }
        $meta_anchor = $meta_anchor.'.html';
        $category->meta_anchor = $meta_anchor;
        $category->update();
        Session::flash('message','Cập nhật danh mục thành công!');
        Session::flash('alert-class','alert-success');
        if($request->has('save-continue')){
            return redirect()->route('be.category.edit',$category->id);
        }
       return redirect()->route('be.category.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * 
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, $id)
    {
        $category = Category::findOrFail($id);
        Category::where('parent_id',$id)->update(['parent_id'=>0]);
        Product::where('category_id',$id)->update(['category_id'=>0,'is_available' => 0]);
        $category->delete();
        Session::flash('message','Xóa danh mục thành công!');
        Session::flash('alert-class','alert-success');
        return redirect('be.category.index');
    }
}

app/Http/Controllers/Backend/CustomerController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Eloquent\Customer;
use Session;

class CustomerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $customers = Customer::all();
        return view('backend.customer.index',compact('customers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backend.customer.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $customer = new Customer();
        $customer->fullname = $request->name;
        $customer->type = $request->type;
        $customer->email = $request->email;
        $customer->phonenumber = $request->phone;
        $customer->address = $request->address;
        $customer->shipping_address = $request->shipping_address;
        if($customer->save())
        {
            Session::flash('message','Thêm khách hàng thành công!');
            Session::flash('alert-class','alert-success');
        }
        else
        {
            Session::flash('message','Không thể thêm mới KH');
            Session::flash('alert-class','alert-danger');
        }
        if($request->has('save-continue'))
        {
            return redirect()->route('be.customer.edit',$customer->id);
            
        }
        return redirect()->route('be.customer.index');

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $customer = Customer::findOrFail($id);
        return view('backend.customer.edit',compact('customer'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $customer = Customer::findOrFail($id);
        return view('backend.customer.edit',compact('customer'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $customer = Customer();
        $customer->fullname = $request->name;
        $customer->type = $request->type;
        $customer->email = $request->email;
        $customer->phonenumber = $request->phone;
        $customer->address = $request->address;
        $customer->shipping_address = $request->shipping_address;
        if($customer->save())
        {
            Session::flash('message','Cập nhật khách hàng thành công!');
            Session::flash('alert-class','alert-success');
        }
        else
        {
            Session::flash('message','Không thể chỉnh sửa KH');
            Session::flash('alert-class','alert-danger');
        }
        if($request->has('save-continue'))
        {
            return redirect()->route('be.customer.edit',$customer->id);
            
        }
        return redirect()->route('be.customer.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        if(Customer::find($id)->delete())
        {
            Session::flash('message','Xóa KH thành công!');
            Session::flash('alert-class','alert-success');
        }
        else
        {
            Session::flash('message','Không thể xóa KH');
            Session::flash('alert-class','alert-danger');
        }
        return redirect()->route('be.customer.index'); 
    }
}

app/Http/Controllers/Backend/DashboardController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class DashboardController extends Controller
{
    //
}

app/Http/Controllers/Backend/SettingController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SettingController extends Controller
{
    //
}

resources/views/backend/order/create.blade.php
@extends('backend.layouts.index')
@section('title','Tạo mới đơn hàng')
@section('page-title','Tạo mới đơn hàng')
@section('parent-breadcrumb','Quản lý đơn hàng')
@section('child-breadcrumb','Tạo mới')
@section('content')
<div class="col-lg-12">
        <form method="post" enctype="multipart/form-data" action="{{ route('be.order.store') }}">
            @csrf
    <div class="card p-0">
        <div class="card-header">
            <span class="font-weight-bold">Tạo mới</span>
            <div class="pull-right">
                <button class="btn btn-info" type="submit" name="save"><i class="fa fa-save"></i> Lưu</button>
                <button class="btn btn-info" type="submit" name="save-continue"><i class="fa fa-save"></i> Lưu và Tiếp tục sửa</button>
            </div>
        </div>
        <div class="card-body">
            <!-- Nav tabs -->
            <ul class="nav nav-tabs customtab">
                <li class="nav-item">
                    <a class="nav-link active" data-toggle="tab" href="#info">Thông tin</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" data-toggle="tab" href="#shipping">SEO</a>
                </li>
            </ul>

            <!-- Tab panes -->
            <div class="tab-content">
                <div class="tab-pane active container pt-2" id="info">
                    <div class="form-group row">
                        <label for="categoryname" class="col-sm-3 col-form-label text-right">Tên danh mục:</label>
                        <div class="col-sm-8">
                            <input type="text" class="form-control" id="categoryname" name="categoryname" required>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="description" class="col-sm-3 col-form-label text-right">Mô tả</label>
                        <div class="col-sm-8">
                            <textarea class="form-control" name="description" id="description" placeholder="Mô tả"></textarea>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="parent_id" class="col-sm-3 col-form-label text-right">Danh mục cha</label>
                        <div class="col-sm-8">
                            <select class="form-control" name="parent_id">
                                <option value="0">[None]</option>
                                @foreach ($categories as $category)
                                <option value="{{ $category->id }}">{{ $category->name }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="image" class="col-sm-3 col-form-label text-right">Hình ảnh</label>
                        <div class="col-sm-8">
                            <input type="file" id="inputGroupFile01" name="image">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="display_order" class="col-sm-3 col-form-label text-right">Ưu tiên hiển thị
                            <i class="fa fa-question-circle text-warning" data-toggle="tooltip" data-placement="top"
                                title="Điểm ưu tiên để sắp xếp thứ tự danh mục trên menu và trên trang chủ"></i>
                        </label>
                        <div class="col-sm-8">
                            <input type="number" class="form-control" name="display_order" id="display_order" value="1">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="display_on_homepage" class="col-sm-3 col-form-label text-right">Hiển thị trên Trang chủ
                            <i class="fa fa-question-circle text-warning" data-toggle="tooltip" data-placement="top"
                                title="Hiện thị sản phẩm của danh mục này trên trang chủ"></i>
                        </label>
                        <div class="col-sm-8">
                            <input type="checkbox" name="display_on_homepage" id="display_on_homepage" value="1">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="display_on_sidebar" class="col-sm-3 col-form-label text-right">Hiển thị trên Menu trái
                            <i class="fa fa-question-circle text-warning" data-toggle="tooltip" data-placement="top"
                                title="Hiện thị danh mục này trên menu trái"></i>
                        </label>
                        <div class="col-sm-8">
                            <input type="checkbox" name="display_on_sidebar" id="display_on_sidebar" value="1">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="display_on_topbar" class="col-sm-3 col-form-label text-right">Hiển thị trên Menu Top
                            <i class="fa fa-question-circle text-warning" data-toggle="tooltip" data-placement="top"
                                title="Hiện thị danh mục này trên menu top"></i>
                        </label>
                        <div class="col-sm-8">
                            <input type="checkbox" name="display_on_topbar" id="display_on_topbar" value="1">
                        </div>
                    </div>

                </div>
                <div class="tab-pane container pt-2" id="seo">
                        <div class="form-group row">
                            <label for="meta_keywords" class="col-sm-3 col-form-label text-right">Meta keywords:</label>
                            <div class="col-sm-8">
                                <input type="text" class="form-control" id="meta_keywords" name="meta_keywords">
                            </div>
                        </div>
                        <div class="form-group row">
                                <label for="meta_description" class="col-sm-3 col-form-label text-right">Meta description:</label>
                                <div class="col-sm-8">
                                    <textarea class="form-control" rows="4" name="meta_description" width="100%"></textarea>   
                                </div>
                        </div>
                        <div class="form-group row">
                                <label for="meta_title" class="col-sm-3 col-form-label text-right">Meta title:</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" name="meta_title">
                                </div>
                        </div>
                        <div class="form-group row">
                                <label for="meta_anchor" class="col-sm-3 col-form-label text-right">SEO Friendly URL: 
                                        <i class="fa fa-question-circle text-warning" data-toggle="tooltip" data-placement="top"
                                        title="Đường dẫn tới danh mục. VD: http://vattusanxuat.net/may-han-cong-nghiep, nếu bỏ trống, phần này sẽ được tự sinh dựa vào tên danh mục"></i>
                                </label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" name="meta_anchor">
                                </div>
                        </div>
                </div>
            </div>    
        </div>
    </form>
    </div>
</div>
@endsection @section('scripts')
<script>
    $('#categoryFormTab a').on('click', function (e) {
        e.preventDefault()
        $(this).tab('show')
    });
</script>

@endsection

resources/views/backend/order/index.blade.php
@extends('backend.layouts.index')
@section('title','Danh sách đơn hàng')
@section('page-title','Đơn hàng')
@section('parent-breadcrumb','Quản lý đơn hàng')
@section('child-breadcrumb','Danh sách')
@section('content')

    <div class="col-lg-12">

        <div class="card">
            <div class="card-header">
                <span class="font-weight-bold">Quản lý đơn hàng</span>
                <a href="{{ route('be.customer.create') }}"><button class="btn btn-success pull-right"><i class="fa fa-plus"></i> Tạo mới</button></a>
            </div>
            <div class="card-body">
                <table class="table">
                    <thead>
                        <th>#</th>
                        <th>Trạng thái</th>
                        <th>Thanh toán</th>       
                        <th>Vận chuyển</th>
                        <th>Khách hàng</th>
                        <th>Ngày tạo</th>
                        <th>Total</th>
                        <th>Control</th>
                    </thead>
                    <tbody>
                        @foreach($orders as $order)
                        <tr>
                            <td>{{ $order->id }}</td>
                            <td>{{ $order->status }}</td>
                            <td>{{ $order->payment_status }}</td>
                            <td>{{ $order->shipment }}</td>
                            <td>{{ $order->customer->name }}</td>
                            <td>{{ $order->created_at }}</td>
                            <td><a href="{{ route('be.order.edit',$attribute->id) }}"><i class="fa fa-pencil"></i></a>
                            </td>
                        </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@endsection